/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */

/* Cherokee
 *
 * Authors:
 *      Alvaro Lopez Ortega <alvaro@alobbs.com>
 *
 * Copyright (C) 2001, 2002, 2003, 2004, 2005 Alvaro Lopez Ortega
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 2 of the GNU General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef CHEROKEE_GNOMEVFS_HANDLER_H
#define CHEROKEE_GNOMEVFS_HANDLER_H

#include "common-internal.h"
#include "buffer.h"
#include "handler.h"

#include <libgnomevfs/gnome-vfs.h>


typedef enum {
	open_none,
	open_requested,
	open_finished
} cherokee_gnomevfs_open_t;

typedef enum {
	read_none,
	read_requested,
	read_finished
} cherokee_gnomevfs_read_t;


typedef struct {
	cherokee_handler_t handler;

	GnomeVFSAsyncHandle *vfs_handler;

	gchar *filedir;
	guint  filedir_len;

	cherokee_gnomevfs_open_t openning;
	cherokee_gnomevfs_read_t reading;

	guint bytes_read;
} cherokee_handler_gnomevfs_t;

#define VFSHANDLER(x)  ((cherokee_handler_gnomevfs_t *)(x))



/* Library init function
 */
void gnomevfs_init ();


ret_t cherokee_handler_gnomevfs_new   (cherokee_handler_t **hdl, void *cnt, cherokee_table_t *properties);

/* virtual methods implementation
 */
ret_t cherokee_handler_gnomevfs_init        (cherokee_handler_gnomevfs_t *hdl);
ret_t cherokee_handler_gnomevfs_free        (cherokee_handler_gnomevfs_t *hdl);
ret_t cherokee_handler_gnomevfs_step        (cherokee_handler_gnomevfs_t *hdl, cherokee_buffer_t *buffer);
ret_t cherokee_handler_gnomevfs_add_headers (cherokee_handler_gnomevfs_t *hdl, cherokee_buffer_t *buffer);


#endif /* CHEROKEE_GNOMEVFS_HANDLER_H */
